VERSION 5.00
Begin VB.UserControl UserControl1 
   BackColor       =   &H00FF0000&
   ClientHeight    =   2310
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3600
   DrawStyle       =   5  'Transparent
   DrawWidth       =   2
   FillStyle       =   0  'Solid
   ScaleHeight     =   2310
   ScaleWidth      =   3600
End
Attribute VB_Name = "UserControl1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long


Public Enum plMode
    pmOffensive = 0
    pmDefensive = 1
End Enum

Dim scores(1) As Integer

Dim NotMoves(7) As Boolean

Dim Board(7, 6) As Integer
Dim TestBoard(7, 6) As Integer
Dim MasterLock As Boolean
'Default Property Values:
Const m_def_PlayMode = 0
Const m_def_PlayerColor = vbRed
Const m_def_ComputerColor = vbYellow
'Property Variables:
Dim m_PlayMode As plMode
Dim m_PlayerColor As OLE_COLOR
Dim m_ComputerColor As OLE_COLOR




Private Sub UserControl_Initialize()
MasterLock = False
UserControl.DrawWidth = 2
UserControl.DrawStyle = 5
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

If MasterLock Then
    ClearBoard
    Refresh
    MasterLock = False
    Exit Sub
End If

'process click
Dim Col As Integer
Dim Row As Integer
Col = GetCol(x)
Row = GetRow(y)
'check it's a valid square
If Col = 0 Then Exit Sub
If Row = 0 Then Exit Sub
'check the square is empty
If Board(Col, Row) > 0 Then Exit Sub
'check there is something below it
If (Row <> 1) And (Board(Col, Row - 1) = 0) Then Exit Sub

'It's a valid move. Make it
Board(Col, Row) = 1
DrawBoard
If CheckWin Then Exit Sub

'Now i'll make a move
GenerateMove
DrawBoard
If CheckWin Then Exit Sub

End Sub

Private Sub UserControl_Paint()
DrawBoard
End Sub

Private Sub UserControl_Resize()
If UserControl.Width <> Screen.TwipsPerPixelX * 357 Then UserControl.Width = Screen.TwipsPerPixelX * 357
If UserControl.Height <> Screen.TwipsPerPixelY * 336 Then UserControl.Height = Screen.TwipsPerPixelY * 336
End Sub

Private Sub DrawBoard()
'draw the counters
Dim outloop As Integer
Dim inloop As Integer
Dim x As Integer
Dim y As Integer

For outloop = 1 To 6
    For inloop = 1 To 7
    'plot at inloop,outloop
    x = 2 + ((inloop - 1) * 51)
    y = 2 + (((7 - outloop) - 1) * 51)
    Select Case Board(inloop, outloop)
        Case 0:
            'blank
            UserControl.FillColor = vbWhite
        Case 1:
            'red
            UserControl.FillColor = m_PlayerColor
        Case 2:
            'yellow
            UserControl.FillColor = m_ComputerColor
    End Select
    Ellipse UserControl.hdc, x, y, x + 47, y + 47
    Next inloop
Next outloop

'plot at 308
Dim message As String
message = "Player : " & scores(0) & "   Computer : " & scores(1)
TextOut UserControl.hdc, ((UserControl.Width / Screen.TwipsPerPixelX) / 2) - ((UserControl.TextWidth(message) / Screen.TwipsPerPixelX) / 2), 310, message, Len(message)

End Sub

Private Sub GenerateMove()
'generate a computer move
'remeber to look at playing mode
Dim MyRow As Integer
Dim MyCol As Integer

'Priority 1 - check if we can win
    If GM_Win Then Exit Sub
'Priority 2 - block player from winning
    If GM_BlockWin Then Exit Sub
'Calculate notwins
    DoNotWins
'Priority 3+4 - get a line of 3 / block a line of 3
    If Me.PlayMode = pmOffensive Then
        If GM_WinThree Then Exit Sub
        If GM_BlockThree Then Exit Sub
    Else
        If GM_BlockThree Then Exit Sub
        If GM_WinThree Then Exit Sub
    End If
'recalc notwins
    DoNotWins2
'Priority 5+6 - get a line of 2 / block a line of 2
    If Me.PlayMode = pmOffensive Then
        If GM_WinTwo Then Exit Sub
        If GM_BlockTwo Then Exit Sub
    Else
        If GM_BlockTwo Then Exit Sub
        If GM_WinTwo Then Exit Sub
    End If

'Priority 7 - Random move
    GM_Rand

End Sub

Private Function GetRow(y As Single) As Integer
Dim pix As Integer
pix = y / Screen.TwipsPerPixelY
pix = 306 - pix
If (pix >= 1) And (pix < 52) Then GetRow = 1
If (pix >= 52) And (pix < 103) Then GetRow = 2
If (pix >= 103) And (pix < 154) Then GetRow = 3
If (pix >= 154) And (pix < 205) Then GetRow = 4
If (pix >= 205) And (pix < 256) Then GetRow = 5
If (pix >= 256) And (pix < 307) Then GetRow = 6
End Function

Private Function GetCol(x As Single) As Integer
Dim pix As Integer
pix = x / Screen.TwipsPerPixelX
If (pix >= 1) And (pix < 52) Then GetCol = 1
If (pix >= 52) And (pix < 103) Then GetCol = 2
If (pix >= 103) And (pix < 154) Then GetCol = 3
If (pix >= 154) And (pix < 205) Then GetCol = 4
If (pix >= 205) And (pix < 256) Then GetCol = 5
If (pix >= 256) And (pix < 307) Then GetCol = 6
If (pix >= 307) And (pix < 358) Then GetCol = 7
End Function

Private Function CheckWin() As Boolean
'check to see if anyone has won
Dim Result As Integer
Dim FullTest As Integer
Dim fullloop As Integer

CopyBoard
Result = WinTestDraw

If Result = 1 Then
    MasterLock = True
    'MsgBox "You Win!"
    scores(0) = scores(0) + 1
    'ClearBoard
    'Refresh
    CheckWin = True
End If

If Result = 2 Then
    MasterLock = True
    'MsgBox "I Win!"
    scores(1) = scores(1) + 1
    'ClearBoard
    'Refresh
    CheckWin = True
End If

If Result = 0 Then
    For fullloop = 1 To 7
        FullTest = FullTest + FindNext(fullloop)
    Next fullloop
    If FullTest = 0 Then
        MasterLock = True
        'MsgBox "Draw!"
        'ClearBoard
        'Refresh
        CheckWin = True
    End If
End If

End Function

Private Function FindNext(Col As Integer) As Integer
'find the next aviliable row in the specified col
FindNext = 0
If Board(Col, 6) = 0 Then FindNext = 6
If Board(Col, 5) = 0 Then FindNext = 5
If Board(Col, 4) = 0 Then FindNext = 4
If Board(Col, 3) = 0 Then FindNext = 3
If Board(Col, 2) = 0 Then FindNext = 2
If Board(Col, 1) = 0 Then FindNext = 1
End Function

Private Function WinTest() As Integer
'test for a win

'if red win, return 1
'if yellow win, return 2
'else return 0

Dim CurRow As Integer
Dim CurCol As Integer
WinTest = 0

'horizontals first
    For CurRow = 1 To 6
        For CurCol = 1 To 4
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow) = 1) And (TestBoard(CurCol + 2, CurRow) = 1) And (TestBoard(CurCol + 3, CurRow) = 1) Then WinTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow) = 2) And (TestBoard(CurCol + 2, CurRow) = 2) And (TestBoard(CurCol + 3, CurRow) = 2) Then WinTest = 2
        Next CurCol
    Next CurRow

'now verticals
    For CurCol = 1 To 7
        For CurRow = 1 To 3
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol, CurRow + 1) = 1) And (TestBoard(CurCol, CurRow + 2) = 1) And (TestBoard(CurCol, CurRow + 3) = 1) Then WinTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol, CurRow + 1) = 2) And (TestBoard(CurCol, CurRow + 2) = 2) And (TestBoard(CurCol, CurRow + 3) = 2) Then WinTest = 2
        Next CurRow
    Next CurCol

'now up diags
    For CurCol = 1 To 4
        For CurRow = 1 To 3
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow + 1) = 1) And (TestBoard(CurCol + 2, CurRow + 2) = 1) And (TestBoard(CurCol + 3, CurRow + 3) = 1) Then WinTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow + 1) = 2) And (TestBoard(CurCol + 2, CurRow + 2) = 2) And (TestBoard(CurCol + 3, CurRow + 3) = 2) Then WinTest = 2
        Next CurRow
    Next CurCol


'lastly, down diags
    For CurCol = 1 To 4
        For CurRow = 4 To 6
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow - 1) = 1) And (TestBoard(CurCol + 2, CurRow - 2) = 1) And (TestBoard(CurCol + 3, CurRow - 3) = 1) Then WinTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow - 1) = 2) And (TestBoard(CurCol + 2, CurRow - 2) = 2) And (TestBoard(CurCol + 3, CurRow - 3) = 2) Then WinTest = 2
        Next CurRow
    Next CurCol



End Function

Private Sub CopyBoard()
Dim Col As Integer
Dim Row As Integer
For Col = 1 To 7
For Row = 1 To 6
TestBoard(Col, Row) = Board(Col, Row)
Next Row
Next Col
End Sub

Private Sub ClearBoard()
Dim Col As Integer
Dim Row As Integer
For Col = 1 To 7
For Row = 1 To 6
Board(Col, Row) = 0
Next Row
Next Col
End Sub

Private Function GM_Win() As Boolean
Dim MyRow As Integer
Dim MyCol As Integer
GM_Win = False
For MyCol = 1 To 7
MyRow = FindNext(MyCol)
If MyRow <> 0 Then
    CopyBoard
    TestBoard(MyCol, MyRow) = 2
    If WinTest = 2 Then
        'we can win - do the move
        Board(MyCol, MyRow) = 2
        GM_Win = True
        Exit Function
    End If
End If
Next MyCol
End Function

Private Function GM_BlockWin() As Boolean
Dim MyRow As Integer
Dim MyCol As Integer
GM_BlockWin = False
For MyCol = 1 To 7
MyRow = FindNext(MyCol)
If MyRow <> 0 Then
    CopyBoard
    TestBoard(MyCol, MyRow) = 1
    If WinTest = 1 Then
        'they can win - do the move
        Board(MyCol, MyRow) = 2
        GM_BlockWin = True
        Exit Function
    End If
End If
Next MyCol

End Function

Private Function GM_WinThree() As Boolean
'get a line of three
Dim MyRow As Integer
Dim MyCol As Integer
GM_WinThree = False
For MyCol = 1 To 7
If Not NotMoves(MyCol) Then
MyRow = FindNext(MyCol)
If MyRow <> 0 Then
    CopyBoard
    TestBoard(MyCol, MyRow) = 2
    If ThreeTest = 2 Then
        'we can get 3 - do the move
        Board(MyCol, MyRow) = 2
        GM_WinThree = True
        Exit Function
    End If
End If
End If
Next MyCol

End Function

Private Function GM_BlockThree() As Boolean
'block a player from getting a line of three
Dim MyRow As Integer
Dim MyCol As Integer
GM_BlockThree = False
For MyCol = 1 To 7
If Not NotMoves(MyCol) Then
MyRow = FindNext(MyCol)
If MyRow <> 0 Then
    CopyBoard
    TestBoard(MyCol, MyRow) = 1
    If ThreeTest = 1 Then
        'they can get 3 - do the move
        Board(MyCol, MyRow) = 2
        GM_BlockThree = True
        Exit Function
    End If
End If
End If
Next MyCol

End Function

Private Function GM_WinTwo() As Boolean
'get a line of two
Dim MyRow As Integer
Dim MyCol As Integer
GM_WinTwo = False
For MyCol = 1 To 7
If Not NotMoves(MyCol) Then
MyRow = FindNext(MyCol)
If MyRow <> 0 Then
    CopyBoard
    TestBoard(MyCol, MyRow) = 2
    If TwoTest = 2 Then
        'we can get 2 - do the move
        Board(MyCol, MyRow) = 2
        GM_WinTwo = True
        Exit Function
    End If
End If
End If
Next MyCol
End Function

Private Function GM_BlockTwo() As Boolean
'block a player from getting a line of two
Dim MyRow As Integer
Dim MyCol As Integer
GM_BlockTwo = False
For MyCol = 1 To 7
If Not NotMoves(MyCol) Then
MyRow = FindNext(MyCol)
If MyRow <> 0 Then
    CopyBoard
    TestBoard(MyCol, MyRow) = 1
    If TwoTest = 1 Then
        'they can get 2 - do the move
        Board(MyCol, MyRow) = 2
        GM_BlockTwo = True
        Exit Function
    End If
End If
End If
Next MyCol
End Function

Private Sub GM_Rand()
Dim MyRow As Integer
Dim MyCol As Integer

Do

MyCol = Int((7 * Rnd) + 1)
MyRow = FindNext(MyCol)

Loop Until (MyRow <> 0) And (NotMoves(MyCol) <> True)

Board(MyCol, MyRow) = 2

End Sub

Private Function ThreeTest() As Integer
'test for a line of 3

'if red win, return 1
'if yellow win, return 2
'else return 0

Dim CurRow As Integer
Dim CurCol As Integer
ThreeTest = 0

'horizontals first
    For CurRow = 1 To 6
        For CurCol = 1 To 5
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow) = 1) And (TestBoard(CurCol + 2, CurRow) = 1) Then ThreeTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow) = 2) And (TestBoard(CurCol + 2, CurRow) = 2) Then ThreeTest = 2
        Next CurCol
    Next CurRow

'now verticals
    For CurCol = 1 To 7
        For CurRow = 1 To 4
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol, CurRow + 1) = 1) And (TestBoard(CurCol, CurRow + 2) = 1) Then ThreeTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol, CurRow + 1) = 2) And (TestBoard(CurCol, CurRow + 2) = 2) Then ThreeTest = 2
        Next CurRow
    Next CurCol

'now up diags
    For CurCol = 1 To 5
        For CurRow = 1 To 4
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow + 1) = 1) And (TestBoard(CurCol + 2, CurRow + 2) = 1) Then ThreeTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow + 1) = 2) And (TestBoard(CurCol + 2, CurRow + 2) = 2) Then ThreeTest = 2
        Next CurRow
    Next CurCol


'lastly, down diags
    For CurCol = 1 To 5
        For CurRow = 3 To 6
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow - 1) = 1) And (TestBoard(CurCol + 2, CurRow - 2) = 1) Then ThreeTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow - 1) = 2) And (TestBoard(CurCol + 2, CurRow - 2) = 2) Then ThreeTest = 2
        Next CurRow
    Next CurCol

End Function

Private Function TwoTest() As Integer
'test for a line of 2

'if red win, return 1
'if yellow win, return 2
'else return 0

Dim CurRow As Integer
Dim CurCol As Integer
TwoTest = 0

'horizontals first
    For CurRow = 1 To 6
        For CurCol = 1 To 6
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow) = 1) Then TwoTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow) = 2) Then TwoTest = 2
        Next CurCol
    Next CurRow

'now verticals
    For CurCol = 1 To 7
        For CurRow = 1 To 5
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol, CurRow + 1) = 1) Then TwoTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol, CurRow + 1) = 2) Then TwoTest = 2
        Next CurRow
    Next CurCol

'now up diags
    For CurCol = 1 To 6
        For CurRow = 1 To 5
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow + 1) = 1) Then TwoTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow + 1) = 2) Then TwoTest = 2
        Next CurRow
    Next CurCol


'lastly, down diags
    For CurCol = 1 To 6
        For CurRow = 2 To 6
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow - 1) = 1) Then TwoTest = 1
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow - 1) = 2) Then TwoTest = 2
        Next CurRow
    Next CurCol

End Function

Private Function WinTestDraw() As Integer
'test for a win

'if red win, return 1
'if yellow win, return 2
'else return 0

Dim CurRow As Integer
Dim CurCol As Integer

WinTestDraw = 0

'horizontals first
    For CurRow = 1 To 6
        For CurCol = 1 To 4
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow) = 1) And (TestBoard(CurCol + 2, CurRow) = 1) And (TestBoard(CurCol + 3, CurRow) = 1) Then
            MarkLine CurCol, CurRow, CurCol + 3, CurRow + 0
            WinTestDraw = 1
         End If
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow) = 2) And (TestBoard(CurCol + 2, CurRow) = 2) And (TestBoard(CurCol + 3, CurRow) = 2) Then
            MarkLine CurCol, CurRow, CurCol + 3, CurRow + 0
            WinTestDraw = 2
         End If
        Next CurCol
    Next CurRow

'now verticals
    For CurCol = 1 To 7
        For CurRow = 1 To 3
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol, CurRow + 1) = 1) And (TestBoard(CurCol, CurRow + 2) = 1) And (TestBoard(CurCol, CurRow + 3) = 1) Then
            MarkLine CurCol, CurRow, CurCol + 0, CurRow + 3
            WinTestDraw = 1
         End If
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol, CurRow + 1) = 2) And (TestBoard(CurCol, CurRow + 2) = 2) And (TestBoard(CurCol, CurRow + 3) = 2) Then
            MarkLine CurCol, CurRow, CurCol + 0, CurRow + 3
            WinTestDraw = 2
         End If
        Next CurRow
    Next CurCol

'now up diags
    For CurCol = 1 To 4
        For CurRow = 1 To 3
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow + 1) = 1) And (TestBoard(CurCol + 2, CurRow + 2) = 1) And (TestBoard(CurCol + 3, CurRow + 3) = 1) Then
            MarkLine CurCol, CurRow, CurCol + 3, CurRow + 3
            WinTestDraw = 1
         End If
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow + 1) = 2) And (TestBoard(CurCol + 2, CurRow + 2) = 2) And (TestBoard(CurCol + 3, CurRow + 3) = 2) Then
            MarkLine CurCol, CurRow, CurCol + 3, CurRow + 3
            WinTestDraw = 2
         End If
        Next CurRow
    Next CurCol


'lastly, down diags
    For CurCol = 1 To 4
        For CurRow = 4 To 6
         If (TestBoard(CurCol, CurRow) = 1) And (TestBoard(CurCol + 1, CurRow - 1) = 1) And (TestBoard(CurCol + 2, CurRow - 2) = 1) And (TestBoard(CurCol + 3, CurRow - 3) = 1) Then
            MarkLine CurCol, CurRow, CurCol + 3, CurRow - 3
            WinTestDraw = 1
         End If
         If (TestBoard(CurCol, CurRow) = 2) And (TestBoard(CurCol + 1, CurRow - 1) = 2) And (TestBoard(CurCol + 2, CurRow - 2) = 2) And (TestBoard(CurCol + 3, CurRow - 3) = 2) Then
            MarkLine CurCol, CurRow, CurCol + 3, CurRow - 3
            WinTestDraw = 2
         End If
        Next CurRow
    Next CurCol



End Function

Private Sub MarkLine(Col1 As Integer, Row1 As Integer, Col2 As Integer, Row2 As Integer)
'draw a line from col1,row1 to col2,row2

Dim x1 As Integer
Dim x2 As Integer
Dim y1 As Integer
Dim y2 As Integer

    x1 = (24 + ((Col1 - 1) * 51)) * Screen.TwipsPerPixelX
    y1 = (24 + (((7 - Row1) - 1) * 51)) * Screen.TwipsPerPixelY
    x2 = (24 + ((Col2 - 1) * 51)) * Screen.TwipsPerPixelX
    y2 = (24 + (((7 - Row2) - 1) * 51)) * Screen.TwipsPerPixelY

UserControl.DrawStyle = 0
UserControl.Line (x1, y1)-(x2, y2)
UserControl.DrawStyle = 5

End Sub

Private Sub DoNotWins()

Dim l As Integer
Dim MyCol As Integer
Dim MyRow As Integer

For l = 1 To 7
    NotMoves(l) = False
Next l

For l = 1 To 7
    If FindNext(l) <> 0 Then
        For MyCol = 1 To 7
            CopyBoard
            'make theoretical move
            TestBoard(l, FindNext(l)) = 2
            'see if they will win
            If FindNextCopy(MyCol) <> 0 Then
                TestBoard(MyCol, FindNextCopy(MyCol)) = 1
                If WinTest = 1 Then NotMoves(l) = True
            End If
        Next MyCol
    End If
Next l

FreeASpace

End Sub

Private Sub DoNotWins2()

Dim l As Integer
Dim MyCol As Integer
Dim MyRow As Integer

For l = 1 To 7
    If FindNext(l) <> 0 Then
        For MyCol = 1 To 7
            CopyBoard
            'make theoretical move
            TestBoard(l, FindNext(l)) = 2
            'see if they will win
            If FindNextCopy(MyCol) <> 0 Then
                TestBoard(MyCol, FindNextCopy(MyCol)) = 1
                If ThreeTest = 1 Then NotMoves(l) = True
            End If
        Next MyCol
    End If
Next l

FreeASpace

End Sub


Private Function FindNextCopy(Col As Integer) As Integer
'find the next aviliable row in the specified col
FindNextCopy = 0
If TestBoard(Col, 6) = 0 Then FindNextCopy = 6
If TestBoard(Col, 5) = 0 Then FindNextCopy = 5
If TestBoard(Col, 4) = 0 Then FindNextCopy = 4
If TestBoard(Col, 3) = 0 Then FindNextCopy = 3
If TestBoard(Col, 2) = 0 Then FindNextCopy = 2
If TestBoard(Col, 1) = 0 Then FindNextCopy = 1
End Function

Private Sub FreeASpace()
Dim l As Integer
For l = 1 To 7
If NotMoves(l) = False And FindNext(l) <> 0 Then Exit Sub
Next l

For l = 1 To 7
    If FindNext(l) <> 0 Then
        NotMoves(l) = False
        Exit Sub
    End If
Next l
End Sub






'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_PlayMode = m_def_PlayMode
    m_PlayerColor = m_def_PlayerColor
    m_ComputerColor = m_def_ComputerColor
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_PlayMode = PropBag.ReadProperty("PlayMode", m_def_PlayMode)
    m_PlayerColor = PropBag.ReadProperty("PlayerColor", m_def_PlayerColor)
    m_ComputerColor = PropBag.ReadProperty("ComputerColor", m_def_ComputerColor)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("PlayMode", m_PlayMode, m_def_PlayMode)
    Call PropBag.WriteProperty("PlayerColor", m_PlayerColor, m_def_PlayerColor)
    Call PropBag.WriteProperty("ComputerColor", m_ComputerColor, m_def_ComputerColor)
End Sub

Public Property Get PlayMode() As plMode
    PlayMode = m_PlayMode
End Property

Public Property Let PlayMode(ByVal New_PlayMode As plMode)
    m_PlayMode = New_PlayMode
    PropertyChanged "PlayMode"
End Property

Public Property Get PlayerColor() As OLE_COLOR
    PlayerColor = m_PlayerColor
End Property

Public Property Let PlayerColor(ByVal New_PlayerColor As OLE_COLOR)
    m_PlayerColor = New_PlayerColor
    PropertyChanged "PlayerColor"
    Refresh
End Property

Public Property Get ComputerColor() As OLE_COLOR
    ComputerColor = m_ComputerColor
End Property

Public Property Let ComputerColor(ByVal New_ComputerColor As OLE_COLOR)
    m_ComputerColor = New_ComputerColor
    PropertyChanged "ComputerColor"
    Refresh
End Property

